<template>
  <main>
    <mt-page-title
      :link-to="{ name: 'infos-persos' }"
      link-text="Retour au profil"
      :with-border="false"
      border-style="padding:1.5rem 0"
    >
      <h1 class="has-text-weight-bold is-size-3">Modifier mes informations</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <div class="columns is-multiline">
        <b-field label="Nom " class="column is-half ">
          <b-input v-model="utilisateur.nom" class="mt-input" required disabled="true" />
        </b-field>
        <b-field label="Prénom " class="column is-half ">
          <b-input v-model="utilisateur.prenom" class="mt-input" required disabled="true" />
        </b-field>
        <b-field label="Email / Identifiant" class="column is-half ">
          <b-input v-model="utilisateur.email" class="mt-input" type="email" required :disabled="estDisable" />
        </b-field>
        <b-field label="Téléphone" class="column is-half ">
          <b-input v-model="utilisateur.telephone" class="mt-input" required :disabled="estDisable" />
        </b-field>
        <b-field label="Profil par défaut" class="column">
          <div class="columns mt-profil-list">
            <b-checkbox
              v-for="userProfil in utilisateur.userProfils"
              :key="`userProfil${userProfil.id}`"
              v-model="userProfil.selected"
              name="pofil"
              class="checkboxProfils"
              @input="changeProfil(userProfil)"
              >{{ userProfil.profil.description }}</b-checkbox
            >
          </div>
        </b-field>

        <b-message v-if="estDisable" type="is-info" has-icon>
          <b>Mise à jour en attente de vérification</b><br />
          Il vous suffit de consulter votre e-mail <b>{{ utilisateur.newEmail }}</b> pour confirmer vos modifications et
          ainsi terminer l'opération de mise à jour.<br />
          <b-button type="is-text" @click="renvoyerMail">
            Renvoyer un e-mail
          </b-button>
          <b-button type="is-text" @click="annulerModifications">
            Annuler les modifications apportées
          </b-button>
        </b-message>
      </div>
      <b-button
        v-if="!estDisable"
        type="is-primary"
        native-type="submit"
        class="mt-margin-top mt-button is-size-8 has-text-weight-semibold"
      >
        Enregistrer
      </b-button>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
  },
  async asyncData({ $api }) {
    const utilisateur = await $api.utilisateurs.me();
    const oldMail = utilisateur.email;
    const oldTelephone = utilisateur.telephone;
    const estDisable = utilisateur.newEmail !== null || utilisateur.newTelephone !== null;
    const { userProfils } = utilisateur;
    const isModifier = false;
    return {
      utilisateur,
      oldMail,
      oldTelephone,
      estDisable,
      userProfils,
      isModifier,
    };
  },
  methods: {
    async submit() {
      try {
        if (this.oldMail !== this.utilisateur.email || this.oldTelephone !== this.utilisateur.telephone) {
          if (!this.validateEmail(this.utilisateur.email)) {
            this.$buefy.notification.open({
              message: "L'addresse e-mail que vous avez saisie n'est pas valide.",
              type: 'is-warning',
              duration: 5000,
            });
          } else {
            this.utilisateur = await this.$api.utilisateurs.modifierInfosPersos(this.utilisateur);
            this.utilisateur = await this.$api.utilisateurs.modifierUserProfil(this.utilisateur);
            this.getVar();
            this.$buefy.notification.open({
              message: `Un e-mail a été envoyé à ${this.utilisateur.newEmail}`,
              type: 'is-warning',
              duration: 5000,
            });
          }
        }
        if (
          this.isModifier &&
          (this.oldMail === this.utilisateur.email || this.oldTelephone === this.utilisateur.telephone)
        ) {
          this.utilisateur = await this.$api.utilisateurs.modifierUserProfil(this.utilisateur);
          this.getVar();
          this.$buefy.notification.open({
            message: `Modification effectuée`,
            type: 'is-warning',
            duration: 5000,
          });
        } else {
          this.$buefy.notification.open({
            message: 'Aucune modification effectuée',
            type: 'is-warning',
            duration: 5000,
          });
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    async annulerModifications() {
      this.utilisateur = await this.$api.utilisateurs.annulerModifierInfosPersos();
      this.getVar();
    },
    async renvoyerMail() {
      this.utilisateur = await this.$api.utilisateurs.renvoyerModifierInfosPersos();
      this.getVar();
      this.$buefy.notification.open({
        message: `Un e-mail a été envoyé à ${this.utilisateur.newEmail}`,
        type: 'is-warning',
        duration: 5000,
      });
    },
    getVar() {
      this.oldMail = this.utilisateur.email;
      this.oldTelephone = this.utilisateur.telephone;
      this.estDisable = this.utilisateur.newEmail !== null || this.utilisateur.newTelephone !== null;
      this.isModifier = false;
    },
    retourInfosPersos() {
      this.$router.push('/infos-persos');
    },
    validateEmail(email) {
      const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },

    changeProfil(data) {
      for (let i = 0; i < this.utilisateur.userProfils.length; i += 1) {
        if (data.id !== this.utilisateur.userProfils[i].id) {
          this.utilisateur.userProfils[i].selected = false;
        }
      }
      this.isModifier = true;
    },
  },
};
</script>
<style scoped lang="scss">
@import '~/assets/css/_variables';
/deep/ .checkboxProfils input {
  visibility: hidden;

  & ~ .control-label {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;
    display: flex;
    align-items: center;

    .icon {
      margin-right: 0.8em;
    }
  }
  &:checked ~ .control-label,
  & ~ .control-label:hover {
    border-color: $soft-blue;
    background-color: $soft-blue;
    color: $white;
  }

  & + .check {
    display: none !important;
    visibility: hidden;
  }
}
</style>
